.386

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE

INCLUDE    \masm32\include\windows.inc
INCLUDE    \masm32\include\kernel32.inc
INCLUDE    \masm32\include\user32.inc
INCLUDE    \masm32\include\comctl32.inc
INCLUDELIB \masm32\lib\comctl32.lib
INCLUDELIB \masm32\lib\user32.lib
INCLUDELIB \masm32\lib\kernel32.lib

DlgProc        PROTO :DWORD, :DWORD, :DWORD, :DWORD
EnumChild      PROTO :DWORD, :DWORD
SetDlgToolArea PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD

.CONST

IDD_MAINDIALOG EQU  101
IDC_EXIT       EQU 1001

.DATA

ToolTipsClassName DB "Tooltips_class32", 0
MainDialogText1   DB "Lewy grny obszar okna dialogowego", 0
MainDialogText2   DB "Prawy grny obszar okna dialogowego", 0
MainDialogText3   DB "Lewy dolny obszar okna dialogowego", 0
MainDialogText4   DB "Prawy dolny obszar okna dialogowego", 0

.DATA?

hwndTool  DD ?
hInstance DD ?

.CODE

start:
    INVOKE GetModuleHandle, NULL
    mov    hInstance, eax
    INVOKE DialogBoxParam, hInstance,\
                           IDD_MAINDIALOG, NULL, ADDR DlgProc, NULL
    INVOKE ExitProcess, eax

DlgProc PROC hDlg:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

LOCAL ti:   TOOLINFO
LOCAL id:   DWORD
LOCAL rect: RECT

    .IF uMsg==WM_INITDIALOG
        INVOKE InitCommonControls
        INVOKE CreateWindowEx, NULL, ADDR ToolTipsClassName, NULL,\
                               TTS_ALWAYSTIP, CW_USEDEFAULT,\
                               CW_USEDEFAULT, CW_USEDEFAULT,\
                               CW_USEDEFAULT, NULL, NULL,\
                               hInstance, NULL
        mov    hwndTool, eax
        mov    id, 0
        mov    ti.cbSize, SIZEOF TOOLINFO
        mov    ti.uFlags, TTF_SUBCLASS
        push   hDlg
        pop    ti.hWnd
        INVOKE GetWindowRect, hDlg, ADDR rect
        INVOKE SetDlgToolArea, hDlg, ADDR ti,\
                               ADDR MainDialogText1, id, ADDR rect
        inc    id
        INVOKE SetDlgToolArea, hDlg, ADDR ti,\
                               ADDR MainDialogText2, id, ADDR rect
        inc    id
        INVOKE SetDlgToolArea, hDlg, ADDR ti,\
                               ADDR MainDialogText3, id, ADDR rect
        inc    id
        INVOKE SetDlgToolArea, hDlg, ADDR ti,\
                               ADDR MainDialogText4, id, ADDR rect
        INVOKE EnumChildWindows, hDlg, ADDR EnumChild, ADDR ti
    .ELSEIF uMsg==WM_CLOSE
        INVOKE EndDialog, hDlg, NULL
    .ELSEIF uMsg==WM_COMMAND
        .IF (lParam!=0) && \
            (WORD PTR wParam + 2 == BN_CLICKED) && \
            (WORD PTR wParam==IDC_EXIT)
            INVOKE EndDialog, hDlg, NULL
        .ENDIF
    .ELSE
        mov eax, FALSE
        ret
    .ENDIF
    mov eax, TRUE
    ret

DlgProc ENDP

EnumChild PROC USES edi hwndChild:DWORD, lParam:DWORD

LOCAL buffer[256]:BYTE

    mov edi, lParam

ASSUME edi: PTR TOOLINFO

    push   hwndChild
    pop    [edi].uId
    or     [edi].uFlags, TTF_IDISHWND
    INVOKE GetWindowText, hwndChild, ADDR buffer, 255
    lea    eax, buffer
    mov    [edi].lpszText, eax
    INVOKE SendMessage, hwndTool, TTM_ADDTOOL, NULL, edi

ASSUME edi: NOTHING

    ret

EnumChild ENDP

SetDlgToolArea PROC USES edi esi hDlg:   DWORD,\
                                 lpti:   DWORD,\
                                 lpText: DWORD,\
                                 id:     DWORD,\
                                 lprect: DWORD

    mov edi, lpti
    mov esi, lprect

ASSUME esi: PTR RECT
ASSUME edi: PTR TOOLINFO

    .IF id==0
        mov [edi].rect.left, 0
        mov [edi].rect.top, 0
        mov eax, [esi].right
        sub eax, [esi].left
        shr eax, 1
        mov [edi].rect.right, eax
        mov eax, [esi].bottom
        sub eax, [esi].top
        shr eax, 1
        mov [edi].rect.bottom, eax
    .ELSEIF id==1
        mov eax, [esi].right
        sub eax, [esi].left
        shr eax, 1
        inc eax
        mov [edi].rect.left, eax
        mov [edi].rect.top, 0
        mov eax, [esi].right
        sub eax, [esi].left
        mov [edi].rect.right, eax
        mov eax, [esi].bottom
        sub eax, [esi].top
        mov [edi].rect.bottom, eax
    .ELSEIF id==2
        mov [edi].rect.left, 0
        mov eax, [esi].bottom
        sub eax, [esi].top
        shr eax, 1
        inc eax
        mov [edi].rect.top, eax
        mov eax, [esi].right
        sub eax, [esi].left
        shr eax, 1
        mov [edi].rect.right, eax
        mov eax, [esi].bottom
        sub eax, [esi].top
        mov [edi].rect.bottom, eax
    .ELSE
        mov eax, [esi].right
        sub eax, [esi].left
        shr eax, 1
        inc eax
        mov [edi].rect.left, eax
        mov eax, [esi].bottom
        sub eax, [esi].top
        shr eax, 1
        inc eax
        mov [edi].rect.top, eax
        mov eax, [esi].right
        sub eax, [esi].left
        mov [edi].rect.right, eax
        mov eax, [esi].bottom
        sub eax, [esi].top
        mov [edi].rect.bottom, eax
    .ENDIF
    push   lpText
    pop    [edi].lpszText
    INVOKE SendMessage, hwndTool, TTM_ADDTOOL, NULL, lpti

ASSUME edi: NOTHING
ASSUME esi: NOTHING

    ret

SetDlgToolArea ENDP

END start
